/**************************************************************
**
**         C SWING  v 3.1   31-JUL-1989 09:09:52.96
**         =========================================
**
**         Author    :  S.J.Brown
**
**         Copyright :  Public Domain
**
**         File      :  SWING_7.C
**
**         Language  :  VAXC
**
**         Compiler  :  VAX/VMS C v 2.4
**
**         VMS Ver.  :  5.1
**
***************************************************************
**
**         Change History
**         ==============
**
**         Date        Change                          Initials
**         ----------------------------------------------------
**         31-JUL-1989 Initial Version v3.0               SJB
**
**************************************************************/
 
/*
**  swing_7
*/
#include stdio
#include rms
#include ssdef
#include lnmdef
#include "swing.h"
#include "swing_refs.h"
#include "more_descrip.h"

static load_node_names(ptr, so_far)
NODE *ptr;
char *so_far;
{
    char dir[SPEC_SIZE+1];

    sprintf(ptr->dir_name,"%s%s]",so_far,ptr->name);

    if (ptr->sister)
        load_node_names(ptr->sister, so_far);

    if (ptr->child)
    {
        sprintf(dir,"%s%s.",so_far,ptr->name);
        load_node_names(ptr->child,dir);
    }
}

load_up_node_names(d)
DSTRUCTURE *d;
{
    char device[SPEC_SIZE+1];

    sprintf(device,"%s[",d->device);
    load_node_names(d->fnp, device);
}

set_default(dir)
char *dir;
{
    int i, status, flag, length;

    char device[SPEC_SIZE+1];
    char directory[SPEC_SIZE+1];
    struct itmlst {
    short buffer_length;
    short item_code;
    long buffer_address;
    long return_length_address;
    long terminator;
    } item_list;

    /*
    **  set dir if specified
    */
    strcpy(directory,dir);

    if (strstr(directory,"[000000") && !strstr(directory,"[000000]"))
    {
        int i=0;
        while (directory[i++] != '[');
        strcpy(&directory[i],&directory[i+7]);
        while (directory[i++] != ']');
        directory[i] == 0;
    }

    status = chdir(directory);
    if (status)
    {
        structure_inconsistent(directory);
        return(FALSE);
    }

    /*
    **  we'll say SS$_NORMAL instead of RMS$_NORMAL
    */
    status = SS$_NORMAL;

    /*
    **  set SYS$DISK up to be the current device
    **  we must if we want to swing to another device
    */
    strcpy(device,dir);

    /*
    **  trim away the directories - leave the disk
    */
    flag = 0;
    for (i = 0 ; i < strlen(device) ; i++)
    {
        if (device[i] == '[')
        {
            /*
            **  beginning of directory
            */
            device[i] = 0;

            /*
            **  don't update unless we have to - save cpu
            */
            if (sys_disk[0] && strcmp(sys_disk,device) == 0)
                goto way_out;

            /*
            **  now set SYS$DISK to device, our device
            */
            if (strlen(device))
            {
                strcpy(sys_disk,device);
                status = lib$set_logical(DSC1("SYS$DISK"),
                                         DSC2(device));
                if (status != SS$_NORMAL && status != SS$_SUPERSEDE)
                    panic(status,"sys$crelnm","set def");
            }
            break;
        }
    }
way_out:;
    return(SS$_NORMAL);
}

show_deleting(nptr,rendition,sisters)
NODE *nptr;
int rendition;
int sisters;
{
    /*
    **  make display better by using batch pasteboard update
    */
    smg$begin_pasteboard_update(&paste);
    show_deleting_1(nptr,rendition,sisters);
    smg$end_pasteboard_update(&paste);
}

show_deleting_1(nptr,rendition,sisters)
NODE *nptr;
int rendition;
int sisters;
{
    if (nptr)
    {
        show_deleting_1(nptr->child,rendition,1);
        render(nptr->line, nptr->level, rendition);
        if (sisters)
            show_deleting_1(nptr->sister,rendition,1);
    }
}
